const LOG = require("npm-niosz-log");
LOG.setAppName("ora-test");
const log = LOG.newLog("main");
const ora = require("./index.js");

const mapperDocument = function(row) {
    return {
        statoDocumento: 2,
        upAggregata: row.UPAGGR,
        codiceUp: row.CODICE_UP,
        dataInizio: row.STARTDATE,
        dataFine: row.STOPDATE,
        dataAggiornamento: row.DATA_AGGIORNAMENTO,
        tipoUp: row.TIPO_UP,
        processo: row.PROCESSO,
        triplettaAggregata: {
          contratto: row.CONTRATTO,
          zona: row.ZONA,
          tipologiaCommerciale: row.TIP_COMM
        },
        locazione: {
          comune: row.COMUNE,
          codiceIstat: row.CODICE_ISTAT,
          indirizzo: row.INDIRIZZO,
          cap: row.CAP,
          provincia: row.PROVINCIA,
          regione: row.REGIONE,
          latitudine: row.LATITUDINE,
          longitudine: row.LONGITUDINE
        },
        flagMigrato: row.FLAGMIGRATO,
        stato: row.STATO,
        fonte: row.FONTE,
        macroFonte: row.MACRO_FONTE,
        noteGenerali: row.NOTEGENERALI,
        noteBilancio: row.NOTEBILANCIO,
        fisica: {
            tensioneRete: row.TENSIONERETE,
            tensioneReteCommerciale: row.TENSIONERETECOMMERCIALE,
            connessioneFisica: row.CONNESSIONEFISICA,
            connessioneBilancio: row.CONNESSIONEBILANCIO,
            potenzaNominale: row.POTENZANOMINALE,
        },
        tipologia: row.TIPOLOGIA,
        gruppoBilancio: row.GRUPPOBILANCIO,
        pne: row.PNE,
        commerciale: {
            proprietarioMisuratori: row.PROPRIETARIOMISURATORI,
            codiceDistributore: row.COD_DISTR,
            distributore: row.DISTR,            
            codUdd: row.COD_UDD,
            udd: row.UDD,
            codRm: row.COD_RM,
            rm: row.RM,
            codMne: row.COD_MNE,
            codicePod: row.CODICEPOD
        },
        a71: {
            idEventoSocietario: row.ID_EVENTOSOCIETARIO,
            acquirenteEvento: row.ACQUIRENTE_EVENTO,
            cedenteEvento: row.CEDENTE_EVENTO,
            flagCreataDaEvento: row.FLAGCREATADAEVENTO
        },
        codicePodGaudi: row.CODICEPODGAUDI,
        flagMag55Mw: row.FLAGMAG55MW,
        flagUvam: row.FLAG_UVAM,
        denominazione: row.DENOMINAZIONE,
        idImpianto: row.IDIMPIANTO,
        combprevalente: row.COMBPREVALENTE
      };
};

const main = async function() {

    log.i("inizio programma");
    var resp = await ora.select({
        "user" : "SAPRE",
        "password" : "m0b-MS1R",
        "connectString" : "ESFPMLD75-1.TERNA.EXT.SSG/MDMES"
    },"SELECT /*+PARALLEL(A,16)*/ A.* FROM MW_UNITA A WHERE ROWNUM <= 1");
    console.log(resp);
    var data = resp.fetch(mapperDocument);
    console.log(data);
    while (data) { 
        console.log(resp);
        data = resp.fetch(true);
    }
    resp.close();
};
main();
